/*******************************************************************************
 * Copyright (c) 2010 IGA Tosiki, NTT DATA BUSINESS BRAINS Corp.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    IGA Tosiki (NTT DATA BUSINESS BRAINS Corp.) - initial API and implementation
 *******************************************************************************/
/*
 * blanco Framework
 * Copyright (C) 2010 NTT DATA BUSINESS BRAINS CORPORATION
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.xls;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.ss.usermodel.Cell;

/**
 * Excel Z - Apache POI ̃Vvȃbp[NXłB
 * 
 * Excel ̃Z킵܂B
 * 
 * @author NDBɉ
 */
public class BlancoXlsCell {
    HSSFCell fCell;

    BlancoXlsCell(final HSSFCell cell) {
        fCell = cell;
    }

    /**
     * Iɕێ POI IuWFNg߂܂B
     * 
     * @return
     */
    public HSSFCell getCell() {
        return fCell;
    }

    /**
     * Zɒlݒ肵܂B
     * 
     * @param value
     */
    public void setValue(final String value) {
        fCell.setCellValue(value);
    }

    /**
     * Zɒlݒ肵܂B
     * 
     * @param value
     */
    public void setValue(final int value) {
        fCell.setCellValue(value);
    }

    /**
     * T|[g͈͂ŁAZ̕擾܂B
     * 
     * TODO ׂĂ̌^T|[gĂ킯ł͂܂B
     * 
     * @return
     */
    public String getStringValue() {
        switch (fCell.getCellType()) {
        case Cell.CELL_TYPE_BLANK:
            return getStringValue(fCell.getCellType(), fCell);
        case Cell.CELL_TYPE_BOOLEAN:
            return getStringValue(fCell.getCellType(), fCell);
        case Cell.CELL_TYPE_NUMERIC:
            return getStringValue(fCell.getCellType(), fCell);
        case Cell.CELL_TYPE_STRING:
            return getStringValue(fCell.getCellType(), fCell);
        case Cell.CELL_TYPE_FORMULA:
            // ̏ꍇɂ̓LbVf[^𗘗p܂B
            return getStringValue(fCell.getCachedFormulaResultType(), fCell);
        default:
            throw new IllegalArgumentException("T|[gĂȂ^:"
                    + fCell.getCellType());
        }
    }

    /**
     * ^ꂽ^ƂăZ̕\擾܂B
     * 
     * @param type
     * @param cell
     * @return
     */
    private static String getStringValue(int type, Cell cell) {
        switch (type) {
        case Cell.CELL_TYPE_BLANK:
            return null;
        case Cell.CELL_TYPE_BOOLEAN:
            return Boolean.toString(cell.getBooleanCellValue());
        case Cell.CELL_TYPE_NUMERIC:
            return Double.toString(cell.getNumericCellValue());
        case Cell.CELL_TYPE_STRING:
            return cell.getStringCellValue();
        default:
            throw new IllegalArgumentException("T|[gĂȂ^:" + type);
        }
    }
}
